# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AutoForwarding(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, disposition=None, email_address=None, enabled=None):
        """
        AutoForwarding - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'disposition': 'str',
            'email_address': 'str',
            'enabled': 'bool'
        }

        self.attribute_map = {
            'disposition': 'disposition',
            'email_address': 'emailAddress',
            'enabled': 'enabled'
        }

        self._disposition = disposition
        self._email_address = email_address
        self._enabled = enabled

    @property
    def disposition(self):
        """
        Gets the disposition of this AutoForwarding.
        The state that a message should be left in after it has been forwarded.

        :return: The disposition of this AutoForwarding.
        :rtype: str
        """
        return self._disposition

    @disposition.setter
    def disposition(self, disposition):
        """
        Sets the disposition of this AutoForwarding.
        The state that a message should be left in after it has been forwarded.

        :param disposition: The disposition of this AutoForwarding.
        :type: str
        """
        allowed_values = ["archive", "dispositionUnspecified", "leaveInInbox", "markRead", "trash"]
        if disposition not in allowed_values:
            raise ValueError(
                "Invalid value for `disposition` ({0}), must be one of {1}"
                .format(disposition, allowed_values)
            )

        self._disposition = disposition

    @property
    def email_address(self):
        """
        Gets the email_address of this AutoForwarding.
        Email address to which all incoming messages are forwarded. This email address must be a verified member of the forwarding addresses.

        :return: The email_address of this AutoForwarding.
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """
        Sets the email_address of this AutoForwarding.
        Email address to which all incoming messages are forwarded. This email address must be a verified member of the forwarding addresses.

        :param email_address: The email_address of this AutoForwarding.
        :type: str
        """

        self._email_address = email_address

    @property
    def enabled(self):
        """
        Gets the enabled of this AutoForwarding.
        Whether all incoming mail is automatically forwarded to another address.

        :return: The enabled of this AutoForwarding.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this AutoForwarding.
        Whether all incoming mail is automatically forwarded to another address.

        :param enabled: The enabled of this AutoForwarding.
        :type: bool
        """

        self._enabled = enabled

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AutoForwarding):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
