# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ForwardingAddress(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, forwarding_email=None, verification_status=None):
        """
        ForwardingAddress - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'forwarding_email': 'str',
            'verification_status': 'str'
        }

        self.attribute_map = {
            'forwarding_email': 'forwardingEmail',
            'verification_status': 'verificationStatus'
        }

        self._forwarding_email = forwarding_email
        self._verification_status = verification_status

    @property
    def forwarding_email(self):
        """
        Gets the forwarding_email of this ForwardingAddress.
        An email address to which messages can be forwarded.

        :return: The forwarding_email of this ForwardingAddress.
        :rtype: str
        """
        return self._forwarding_email

    @forwarding_email.setter
    def forwarding_email(self, forwarding_email):
        """
        Sets the forwarding_email of this ForwardingAddress.
        An email address to which messages can be forwarded.

        :param forwarding_email: The forwarding_email of this ForwardingAddress.
        :type: str
        """

        self._forwarding_email = forwarding_email

    @property
    def verification_status(self):
        """
        Gets the verification_status of this ForwardingAddress.
        Indicates whether this address has been verified and is usable for forwarding. Read-only.

        :return: The verification_status of this ForwardingAddress.
        :rtype: str
        """
        return self._verification_status

    @verification_status.setter
    def verification_status(self, verification_status):
        """
        Sets the verification_status of this ForwardingAddress.
        Indicates whether this address has been verified and is usable for forwarding. Read-only.

        :param verification_status: The verification_status of this ForwardingAddress.
        :type: str
        """
        allowed_values = ["accepted", "pending", "verificationStatusUnspecified"]
        if verification_status not in allowed_values:
            raise ValueError(
                "Invalid value for `verification_status` ({0}), must be one of {1}"
                .format(verification_status, allowed_values)
            )

        self._verification_status = verification_status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ForwardingAddress):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
