# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ListHistoryResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, history=None, history_id=None, next_page_token=None):
        """
        ListHistoryResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'history': 'list[History]',
            'history_id': 'str',
            'next_page_token': 'str'
        }

        self.attribute_map = {
            'history': 'history',
            'history_id': 'historyId',
            'next_page_token': 'nextPageToken'
        }

        self._history = history
        self._history_id = history_id
        self._next_page_token = next_page_token

    @property
    def history(self):
        """
        Gets the history of this ListHistoryResponse.
        List of history records. Any messages contained in the response will typically only have id and threadId fields populated.

        :return: The history of this ListHistoryResponse.
        :rtype: list[History]
        """
        return self._history

    @history.setter
    def history(self, history):
        """
        Sets the history of this ListHistoryResponse.
        List of history records. Any messages contained in the response will typically only have id and threadId fields populated.

        :param history: The history of this ListHistoryResponse.
        :type: list[History]
        """

        self._history = history

    @property
    def history_id(self):
        """
        Gets the history_id of this ListHistoryResponse.
        The ID of the mailbox's current history record.

        :return: The history_id of this ListHistoryResponse.
        :rtype: str
        """
        return self._history_id

    @history_id.setter
    def history_id(self, history_id):
        """
        Sets the history_id of this ListHistoryResponse.
        The ID of the mailbox's current history record.

        :param history_id: The history_id of this ListHistoryResponse.
        :type: str
        """

        self._history_id = history_id

    @property
    def next_page_token(self):
        """
        Gets the next_page_token of this ListHistoryResponse.
        Page token to retrieve the next page of results in the list.

        :return: The next_page_token of this ListHistoryResponse.
        :rtype: str
        """
        return self._next_page_token

    @next_page_token.setter
    def next_page_token(self, next_page_token):
        """
        Sets the next_page_token of this ListHistoryResponse.
        Page token to retrieve the next page of results in the list.

        :param next_page_token: The next_page_token of this ListHistoryResponse.
        :type: str
        """

        self._next_page_token = next_page_token

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ListHistoryResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
