# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PopSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, access_window=None, disposition=None):
        """
        PopSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'access_window': 'str',
            'disposition': 'str'
        }

        self.attribute_map = {
            'access_window': 'accessWindow',
            'disposition': 'disposition'
        }

        self._access_window = access_window
        self._disposition = disposition

    @property
    def access_window(self):
        """
        Gets the access_window of this PopSettings.
        The range of messages which are accessible via POP.

        :return: The access_window of this PopSettings.
        :rtype: str
        """
        return self._access_window

    @access_window.setter
    def access_window(self, access_window):
        """
        Sets the access_window of this PopSettings.
        The range of messages which are accessible via POP.

        :param access_window: The access_window of this PopSettings.
        :type: str
        """
        allowed_values = ["accessWindowUnspecified", "allMail", "disabled", "fromNowOn"]
        if access_window not in allowed_values:
            raise ValueError(
                "Invalid value for `access_window` ({0}), must be one of {1}"
                .format(access_window, allowed_values)
            )

        self._access_window = access_window

    @property
    def disposition(self):
        """
        Gets the disposition of this PopSettings.
        The action that will be executed on a message after it has been fetched via POP.

        :return: The disposition of this PopSettings.
        :rtype: str
        """
        return self._disposition

    @disposition.setter
    def disposition(self, disposition):
        """
        Sets the disposition of this PopSettings.
        The action that will be executed on a message after it has been fetched via POP.

        :param disposition: The disposition of this PopSettings.
        :type: str
        """
        allowed_values = ["archive", "dispositionUnspecified", "leaveInInbox", "markRead", "trash"]
        if disposition not in allowed_values:
            raise ValueError(
                "Invalid value for `disposition` ({0}), must be one of {1}"
                .format(disposition, allowed_values)
            )

        self._disposition = disposition

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PopSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
