# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class SmimeInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, encrypted_key_password=None, expiration=None, id=None, is_default=None, issuer_cn=None, pem=None, pkcs12=None):
        """
        SmimeInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'encrypted_key_password': 'str',
            'expiration': 'str',
            'id': 'str',
            'is_default': 'bool',
            'issuer_cn': 'str',
            'pem': 'str',
            'pkcs12': 'str'
        }

        self.attribute_map = {
            'encrypted_key_password': 'encryptedKeyPassword',
            'expiration': 'expiration',
            'id': 'id',
            'is_default': 'isDefault',
            'issuer_cn': 'issuerCn',
            'pem': 'pem',
            'pkcs12': 'pkcs12'
        }

        self._encrypted_key_password = encrypted_key_password
        self._expiration = expiration
        self._id = id
        self._is_default = is_default
        self._issuer_cn = issuer_cn
        self._pem = pem
        self._pkcs12 = pkcs12

    @property
    def encrypted_key_password(self):
        """
        Gets the encrypted_key_password of this SmimeInfo.
        Encrypted key password, when key is encrypted.

        :return: The encrypted_key_password of this SmimeInfo.
        :rtype: str
        """
        return self._encrypted_key_password

    @encrypted_key_password.setter
    def encrypted_key_password(self, encrypted_key_password):
        """
        Sets the encrypted_key_password of this SmimeInfo.
        Encrypted key password, when key is encrypted.

        :param encrypted_key_password: The encrypted_key_password of this SmimeInfo.
        :type: str
        """

        self._encrypted_key_password = encrypted_key_password

    @property
    def expiration(self):
        """
        Gets the expiration of this SmimeInfo.
        When the certificate expires (in milliseconds since epoch).

        :return: The expiration of this SmimeInfo.
        :rtype: str
        """
        return self._expiration

    @expiration.setter
    def expiration(self, expiration):
        """
        Sets the expiration of this SmimeInfo.
        When the certificate expires (in milliseconds since epoch).

        :param expiration: The expiration of this SmimeInfo.
        :type: str
        """

        self._expiration = expiration

    @property
    def id(self):
        """
        Gets the id of this SmimeInfo.
        The immutable ID for the SmimeInfo.

        :return: The id of this SmimeInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this SmimeInfo.
        The immutable ID for the SmimeInfo.

        :param id: The id of this SmimeInfo.
        :type: str
        """

        self._id = id

    @property
    def is_default(self):
        """
        Gets the is_default of this SmimeInfo.
        Whether this SmimeInfo is the default one for this user's send-as address.

        :return: The is_default of this SmimeInfo.
        :rtype: bool
        """
        return self._is_default

    @is_default.setter
    def is_default(self, is_default):
        """
        Sets the is_default of this SmimeInfo.
        Whether this SmimeInfo is the default one for this user's send-as address.

        :param is_default: The is_default of this SmimeInfo.
        :type: bool
        """

        self._is_default = is_default

    @property
    def issuer_cn(self):
        """
        Gets the issuer_cn of this SmimeInfo.
        The S/MIME certificate issuer's common name.

        :return: The issuer_cn of this SmimeInfo.
        :rtype: str
        """
        return self._issuer_cn

    @issuer_cn.setter
    def issuer_cn(self, issuer_cn):
        """
        Sets the issuer_cn of this SmimeInfo.
        The S/MIME certificate issuer's common name.

        :param issuer_cn: The issuer_cn of this SmimeInfo.
        :type: str
        """

        self._issuer_cn = issuer_cn

    @property
    def pem(self):
        """
        Gets the pem of this SmimeInfo.
        PEM formatted X509 concatenated certificate string (standard base64 encoding). Format used for returning key, which includes public key as well as certificate chain (not private key).

        :return: The pem of this SmimeInfo.
        :rtype: str
        """
        return self._pem

    @pem.setter
    def pem(self, pem):
        """
        Sets the pem of this SmimeInfo.
        PEM formatted X509 concatenated certificate string (standard base64 encoding). Format used for returning key, which includes public key as well as certificate chain (not private key).

        :param pem: The pem of this SmimeInfo.
        :type: str
        """

        self._pem = pem

    @property
    def pkcs12(self):
        """
        Gets the pkcs12 of this SmimeInfo.
        PKCS#12 format containing a single private/public key pair and certificate chain. This format is only accepted from client for creating a new SmimeInfo and is never returned, because the private key is not intended to be exported. PKCS#12 may be encrypted, in which case encryptedKeyPassword should be set appropriately.

        :return: The pkcs12 of this SmimeInfo.
        :rtype: str
        """
        return self._pkcs12

    @pkcs12.setter
    def pkcs12(self, pkcs12):
        """
        Sets the pkcs12 of this SmimeInfo.
        PKCS#12 format containing a single private/public key pair and certificate chain. This format is only accepted from client for creating a new SmimeInfo and is never returned, because the private key is not intended to be exported. PKCS#12 may be encrypted, in which case encryptedKeyPassword should be set appropriately.

        :param pkcs12: The pkcs12 of this SmimeInfo.
        :type: str
        """

        self._pkcs12 = pkcs12

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SmimeInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
