# coding: utf-8

"""
    Gmail

    Access Gmail mailboxes including sending user email.

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class SmtpMsa(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, host=None, password=None, port=None, security_mode=None, username=None):
        """
        SmtpMsa - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host': 'str',
            'password': 'str',
            'port': 'int',
            'security_mode': 'str',
            'username': 'str'
        }

        self.attribute_map = {
            'host': 'host',
            'password': 'password',
            'port': 'port',
            'security_mode': 'securityMode',
            'username': 'username'
        }

        self._host = host
        self._password = password
        self._port = port
        self._security_mode = security_mode
        self._username = username

    @property
    def host(self):
        """
        Gets the host of this SmtpMsa.
        The hostname of the SMTP service. Required.

        :return: The host of this SmtpMsa.
        :rtype: str
        """
        return self._host

    @host.setter
    def host(self, host):
        """
        Sets the host of this SmtpMsa.
        The hostname of the SMTP service. Required.

        :param host: The host of this SmtpMsa.
        :type: str
        """

        self._host = host

    @property
    def password(self):
        """
        Gets the password of this SmtpMsa.
        The password that will be used for authentication with the SMTP service. This is a write-only field that can be specified in requests to create or update SendAs settings; it is never populated in responses.

        :return: The password of this SmtpMsa.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this SmtpMsa.
        The password that will be used for authentication with the SMTP service. This is a write-only field that can be specified in requests to create or update SendAs settings; it is never populated in responses.

        :param password: The password of this SmtpMsa.
        :type: str
        """

        self._password = password

    @property
    def port(self):
        """
        Gets the port of this SmtpMsa.
        The port of the SMTP service. Required.

        :return: The port of this SmtpMsa.
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """
        Sets the port of this SmtpMsa.
        The port of the SMTP service. Required.

        :param port: The port of this SmtpMsa.
        :type: int
        """

        self._port = port

    @property
    def security_mode(self):
        """
        Gets the security_mode of this SmtpMsa.
        The protocol that will be used to secure communication with the SMTP service. Required.

        :return: The security_mode of this SmtpMsa.
        :rtype: str
        """
        return self._security_mode

    @security_mode.setter
    def security_mode(self, security_mode):
        """
        Sets the security_mode of this SmtpMsa.
        The protocol that will be used to secure communication with the SMTP service. Required.

        :param security_mode: The security_mode of this SmtpMsa.
        :type: str
        """
        allowed_values = ["none", "securityModeUnspecified", "ssl", "starttls"]
        if security_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `security_mode` ({0}), must be one of {1}"
                .format(security_mode, allowed_values)
            )

        self._security_mode = security_mode

    @property
    def username(self):
        """
        Gets the username of this SmtpMsa.
        The username that will be used for authentication with the SMTP service. This is a write-only field that can be specified in requests to create or update SendAs settings; it is never populated in responses.

        :return: The username of this SmtpMsa.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """
        Sets the username of this SmtpMsa.
        The username that will be used for authentication with the SMTP service. This is a write-only field that can be specified in requests to create or update SendAs settings; it is never populated in responses.

        :param username: The username of this SmtpMsa.
        :type: str
        """

        self._username = username

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SmtpMsa):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
